
C     THE NAME OF THE PROGRAM IS:convfin.f
C     EXAMPLE 10.3
C     THIS PROGRAM MUST BE COMPILED ALONG WITH tdma.f. 
C     COMPILATION COMMAND:f77 convfin.f TDMA.F 
C     THE INPUT DATA ARE TO ENTERED IN AN INTERACTIVE MANNER.
      DIMENSION A(50),B(50),C(50),D(50),THETA(50),X(50),ATHETA(50)     
      INTEGER P,Q,R,S
      REAL K,M,L 
      OPEN(UNIT=1,FILE='N.TXT')
      WRITE(*,*) '    PROGRAM TO CALCULATE TEMPERATURE DISTRIBUTION '    
      WRITE(*,*) '           IN A FIN WITH CONVECTING TIP  '
      WRITE(*,*) '   '
      WRITE(*,*) ' ENTER THE VALUE OF N (N+1 IS THE NO. OF GRID POINTS)'
      WRITE(*,*) '  '
      WRITE(*,*) ' ENTER THE VALUE OF K (THERMAL CONDUCTIVITY)'
      WRITE(*,*) ' '
      WRITE(*,*) ' RESULTS ARE STORED IN THE FILE N.TXT       '
      READ *,N,K
      DO 10  P=2,N-1
 10   A(P)= -1       
      A(N)= -2
      DO 20 Q=1,N-1
      M=SQRT(5000.0/K)
      L=0.1
      O=M*L
      DX=1.0/N
      X(1)=DX
      D1=2.0+(O**2)*(DX**2)
      Z=(5.0*DX)/K
 20   B(Q)= D1
      B(N)=D1+Z
      DO 30 R=1,N-1
 30   C(R)= -1
      D(1)=1
      DO 40 S=2,N
 40   D(S)= 0
      HM=25.0/(M*K)
      DO 5 I=2,N
      X(I)=X(I-1)+DX
      OL=(O*(1-(X(I)))) 
      ATHETA(I)=(COSH(OL)+HM*SINH(OL))/(COSH(O)+HM*SINH(O))     
  5   CONTINUE     
      OL=(O*(1-(X(1))))
      ATHETA(1)=(COSH(OL)+HM*SINH(OL))/(COSH(O)+HM*SINH(O)) 
      CALL TDMA(1,N,A,B,C,D,THETA)  
      WRITE(1,*)'DIMENSIONLESS    DIMENSIONLESS     DIMENSIONLESS '
      WRITE(1,*)'    LENGTH        TEMPERATURE       TEMPERATURE  '            
      WRITE(1,*)'                  (NUMERICAL)       (ANALYTICAL)'
      WRITE(1,25)(X(I),THETA(I),ATHETA(I),I=1,N)
 25   FORMAT(4X,F4.2,4X,F15.4,4X,F15.4)
      CLOSE(UNIT=1)
      STOP
      END

